﻿using System;
using System.Collections.ObjectModel;
using System.Linq;
using System.Windows;
using ExpandItemsIntoView;
using Telerik.Windows.Controls.GridView;
using System.Windows.Input;
using System.Collections.Generic;
using Telerik.Windows.Controls;
using System.Reflection;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DataContext = new ObservableCollection<MyObject>(from i in Enumerable.Range(0, 100)
                                                             select new MyObject()
                                                             {
                                                                 ID = i,
                                                                 Name = string.Format("Name{0}", i),
                                                                 Items = new ObservableCollection<MyObject>(from j in Enumerable.Range(0, 100)
                                                                                                            select new MyObject()
                                                                                                            {
                                                                                                                ID = j,
                                                                                                                Name = string.Format("Name{0}", j),
                                                                                                                Items = new ObservableCollection<MyObject>(from k in Enumerable.Range(0, 100)
                                                                                                                                                           select new MyObject()
                                                                                                                                                           {
                                                                                                                                                               ID = k,
                                                                                                                                                               Name = string.Format("Name{0}", k)
                                                                                                                                                           })
                                                                                                            })
                                                             });


            this.RadTreeListView1.AddHandler(GridViewHeaderCell.MouseLeftButtonDownEvent, new MouseButtonEventHandler(MouseLeftButtonDownHandler), true);
        }

        private Dictionary<GridViewColumn, bool> areColumnsSelectedDictionary = new Dictionary<GridViewColumn, bool>();
        private void MouseLeftButtonDownHandler(object sender, MouseButtonEventArgs e)
        {

            var clickedElement = e.OriginalSource as FrameworkElement;

            if (clickedElement != null)
            {
                var headerCell = clickedElement.ParentOfType<GridViewHeaderCell>();
                if (headerCell != null)
                {
                    var gridViewColumn = headerCell.Column;

                    if (gridViewColumn != null && gridViewColumn.DisplayIndex > -1 && gridViewColumn.DisplayIndex != (gridViewColumn.DataControl as RadTreeListView).HierarchyColumnIndex)
                    {
                        var columnRegion = new CellRegion(gridViewColumn.DisplayIndex, 0, 1, gridViewColumn.DataControl.Items.Count);

                        var selectionProperty = typeof(GridViewDataControl).GetProperty("Selection", BindingFlags.NonPublic | BindingFlags.Instance);
                        var selection = selectionProperty.GetValue(gridViewColumn.DataControl, null);
                        if (!areColumnsSelectedDictionary[gridViewColumn])
                        {
                            var selectCellRegionMethod = selection.GetType().GetMethod("SelectCellRegion");
                            selectCellRegionMethod.Invoke(selection, new object[] { columnRegion });
                            areColumnsSelectedDictionary[gridViewColumn] = true;
                        }
                        else
                        {
                            var unSelectCellRegionMethod = selection.GetType().GetMethod("UnselectCellRegion");
                            unSelectCellRegionMethod.Invoke(selection, new object[] { columnRegion });
                            areColumnsSelectedDictionary[gridViewColumn] = false;
                        }
                    }
                }

            }
        }



        private void RadTreeListView1_Loaded(object sender, RoutedEventArgs e)
        {
            var treeListView = sender as RadTreeListView;
            foreach (var column in treeListView.Columns)
            {
                this.areColumnsSelectedDictionary[column] = false;
            }
        }
    }
}
